"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const directory_scanner_1 = require("directory-scanner");
const lodash_1 = require("lodash");
const scanner = new directory_scanner_1.Scanner();
const typeDefs = new Array();
const resolvers = new Array();
scanner.fileHandler = (o, fn, fp) => __awaiter(this, void 0, void 0, function* () {
    const extname = path.extname(fn);
    if (extname == '.schema' || extname == '.graphql') {
        const content = fs.readFileSync(fp).toString();
        typeDefs.push(content);
    }
    if (extname == '.js') {
        const resolver = require(fp);
        resolvers.push(resolver);
    }
    if (extname == '.ts') {
        const resolver = require(fp).default;
        resolvers.push(resolver);
    }
});
const loader = function (dirRealPath) {
    scanner.scan(dirRealPath);
    return { typeDefs, resolvers: lodash_1.merge({}, ...resolvers) };
};
exports.loader = loader;
